



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>当Scheduler拿不到url的 时候，不能立即退出</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">当Scheduler拿不到url的 时候，不能立即退出</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 13:06:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>在webmagic的多线程抓取中有一个比较麻烦的问题：当Scheduler拿不到url的 时候，不能立即退出，需要等到没抓完的线程都运行完毕，没有新url产生时，才能退出。之前使用Thread.sleep来实现，当拿不到url 时，sleep一段时间再取，确定没有线程执行之后，再退出。</p>
<p>但是这种方式始终不够优雅。Java里面有wait/notify机制可以解决这种同步的问题。于是webmagic 0.4.0用wait/notify机制代替了之前的Thread.sleep机制。代码如下：</p>
<pre class="prettyprint linenums"><code>    while (!Thread.currentThread().isInterrupted() &amp;&amp; stat.get() == STAT_RUNNING) {
        Request request = scheduler.poll(this);
        if (request == null) {
            if (threadAlive.get() == 0 &amp;&amp; exitWhenComplete) {
                break;
            }
            // wait until new url added
            waitNewUrl();
        } else {
            final Request requestFinal = request;
            threadAlive.incrementAndGet();
            executorService.execute(new Runnable() {
                @Override
                public void run() {
                    try {
                        processRequest(requestFinal);
                    } catch (Exception e) {
                        logger.error("download " + requestFinal + " error", e);
                    } finally {
                        threadAlive.decrementAndGet();
                        signalNewUrl();
                    }
                }
            });
        }
    }

private void waitNewUrl() {
    try {
        newUrlLock.lock();
        try {
            newUrlCondition.await();
        } catch (InterruptedException e) {
        }
    } finally {
        newUrlLock.unlock();
    }
}
</code></pre>
<p>这里当线程完成之后，会调用<code>signalNewUrl()</code>来通知主线程，停止等待！</p>
<p>0.4.0发布之后，有用户问我，为什么有的时候抓完无法退出？我开始就怀疑这里可能存在线程安全问题，但是苦于无法复现。</p>
<p>思考了一下，有可能存在这样执行情况：</p>
<ol><li>threadAlive&gt;0，执行<code>if (threadAlive.get() == 0 &amp;&amp; exitWhenComplete)</code>check跳过，于是准备进入<code>waitNewUrl()</code>;</li>
<li>此时最后一个子线程执行结束，<code>threadAlive.decrementAndGet();</code>和<code>signalNewUrl();</code>相继执行；</li>
<li>此时主线程进入<code>waitNewUrl()</code>，结果已无线程执行，也无人可以notify它了，于是线程一直等待&hellip;</li></ol>
<p>那么似乎在lock里加入double-check就OK了？但是今天看了<a href="http://coolshell.cn/articles/4576.html" rel="external nofollow noreferrer">http://coolshell.cn/articles/4576.html</a>这篇文章，大概意思是：出了问题不要靠猜！一定要复现并测试！</p>
<p>于是决定手动模拟！开启10个线程，并mock了所有部件，循环10000次去执行，代码不贴了，地址：<a href="https://github.com/code4craft/webmagic/blob/master/webmagic-core/src/test/java/us/codecraft/webmagic/SpiderTest.java" rel="external nofollow noreferrer">https://github.com/code4craft/webmagic/blob/master/webmagic-core/src/test/java/us/codecraft/webmagic/SpiderTest.java</a>。执行一下，果然到了第13次就卡住了！jstack之后，果然卡在<code>newUrlCondition.await();</code>这里！</p>
<p>然后加入double-check:</p>
<pre class="prettyprint linenums"><code>private void waitNewUrl() {
    try {
        newUrlLock.lock();
        //double check
        if (threadAlive.get() == 0 &amp;&amp; exitWhenComplete) {
            return;
        }
        try {
            newUrlCondition.await();
        } catch (InterruptedException e) {
        }
    } finally {
        newUrlLock.unlock();
    }
}
</code></pre>
<p>结果执行成功！至此问题解决！</p>
<p>经过这个例子，也大致明白了为什么wait/notify之前总是要先<code>lock</code>。为什么呢？有机会写一篇文章总结一下吧！</p>
<p>很简单，是吧？其实这篇文章只想说明一件事：出了bug不要靠猜！一定要复现并确认解决！</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93p12g8.html">MVC 问答</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kmpg39.html">Gravatar注册</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mkd30q.html">Effective c&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k2xj78.html">GridLayout自定义数字键盘&lpar;两个EditText&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e3gkzq.html">java提高篇&lpar;十三&rpar;-----equals&lpar;&rpar;方法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/390orx39.html">centos安装配置nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdz6y48.html">php删除多重数组对象属性，重新赋值的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd4e5e8.html">UI开发中的Unit test新工具：网页抓屏比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mw6r1q.html">HDU-2561                                      第二小整数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdppgl7q.html">LeetCodeOJ&period; Longest Common Prefix</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me1ldrq.html">四 Memcache</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvkp3l8.html">MySQL&mdash;ORM框架，sqlalchemy模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdpx39.html">freemarker 简单操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdgwn9.html">【BZOJ3451】Normal （点分治）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlln5w1q.html">OS &plus; CentOS 7 &sol; firefox</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1nor49.html">【blog】用emoji-java解决Emoji存储MySQL乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rlze68.html">java date HHmmss hhmmss</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjnkx08.html">ML&mdash;机器学习常用包（持续更新&hellip;&period;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kojjr5q.html">ArchLinux 启动等待1分半的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk64pd8.html">JavaWeb学习&mdash;思维导图</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/950r4d68.html">&lbrack;置顶&rsqb; Android中使用sqlite3操作SQLite</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1wmkdq.html">JS乘法口诀表&lpar;一行代码&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m7wno8.html">Android studio&colon; 自 maven 增加一個函式庫</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp06vzq.html">JAVA UTF-8字符转换为GBK</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp10dr9.html">LoadRunner监控数据库服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdjjok9.html">&lbrack;置顶&rsqb; 浅谈Android的资源编译过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1v121q.html">QNX 线程 调度策略 优先级 时钟频率 同步</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljmjrx9.html">带dos调试窗口的win32程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1ve5xq.html">android&mdash;&mdash;写xml</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp1og69.html">Keepalived安装工具</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
